<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <title>List Contact</title>
    <style>
        body {
            line-height: 1;
        }

        table.table-bordered {
            border: 1px solid white;
        }

        table.table-bordered>thead>tr>th {
            border: 1px solid white;
        }

        table.table-bordered>tbody>tr>td {
            border: 1px solid white;
        }

        table thead {
            background-color: #5B9AD4;
        }
    </style>
</head>

<body onload="onPageLoading()">
    <div class="container-fluid pt-4">
        <h2 class="text-center pb-3 font-weight-bold">DANH SÁCH LIÊN HỆ</h2>
        <table class="table table-striped .table-hover table-bordered" id="table-contact">
            <thead>
                <tr>
                    <th scope="col" class="text-white">STT</th>
                    <th scope="col" class="text-white">Name</th>
                    <th scope="col" class="text-white">Email</th>
                    <th scope="col" class="text-white">Message</th>
                    <th scope="col" class="text-white">Ngày liên hệ</th>
                    <th scope="col" class="text-white">Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_CREATE_SUCCESS = 201; // status 201 - tạo thành công
    const gREQUEST_DELETE_SUCCESS = 204; // status 204 - Xóa thành công
    const gBASE_URL = "https://62442d9d3da3ac772b0c50eb.mockapi.io/api/v1/";
    const gEND_ROW_TABLE = -1;
    // hằng số số thứ tự các cột
    const gCOLUMN_STT = 0;
    const gCOLUMN_NAME = 1;
    const gCOLUMN_EMAIL = 2;
    const gCOLUMN_MESSAGE = 3;
    const gCOLUMN_DATE = 4;
    const gCOLUMN_ACTION = 5;
    const gDETAIL_FORM_URL = "contactDetail.html";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */


    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        getAllContacts();
    }

    function onBtnSuaClick(paramButtonChange) {
        // thu thập dữ liệu
        var vId = paramButtonChange.dataset.id;
        console.log("Contact ID: "+vId); 
        // gọi và truyền data qua form Detail
        var vUrlSiteToOpen = gDETAIL_FORM_URL +
            "?id=" + vId;
        window.location.href = vUrlSiteToOpen;
    }

    function onBtnXoaClick(paramButtonDelete) {
        var vDeleteConfirm = confirm("Bạn có chắc chắn muốn xóa liên hệ này?");
        if (vDeleteConfirm) {
            // thu thập dữ liệu
            var vId = paramButtonDelete.dataset.id;
            console.log("Contact id: " + vId);
            var vXmlHttpDeleteContact = new XMLHttpRequest();
            callApiDeleteContact(vId, vXmlHttpDeleteContact);
            informDeleteContact(vId, vXmlHttpDeleteContact);
        }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function getAllContacts() {
        // B1: Thu thập dữ liệu (trong bài này bước này ko cần)
        // B2: Validate dữ liệu (trong bài này bước này ko cần)
        // B3: Thực hiện việc gọi API từ server Server
        var vXmlhttp = new XMLHttpRequest();
        callApiGetContactList(vXmlhttp);
        vXmlhttp.onreadystatechange = function(){
            if(this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK){
                console.log(vXmlhttp.responseText);
                // B4: Xử lý trên front-end khi request xử lý xong và trả về response thành công
                loadContactsToTable(vXmlhttp);
            }    
        }
        
    }

    function callApiGetContactList(paramXmlHttp) {
        var vAPI_URL = gBASE_URL + "/contacts";
        paramXmlHttp.open("GET", vAPI_URL, true);
        paramXmlHttp.send();
    }

    function loadContactsToTable(paramXmlHttp) {
        var vAllContactResponse = JSON.parse(paramXmlHttp.responseText);
        var vTable = document.getElementById("table-contact");
        var vTableBody = vTable.getElementsByTagName("tbody")[0]; //lấy tagname tbody vì nếu trỏ vào table cũng được nhưng nó sẽ vào thẻ thead
        vTableBody.innerHTML = "";
            for (var bIndex = 0; bIndex < vAllContactResponse.length; bIndex++) {
                var vContact = vAllContactResponse[bIndex];
                // tạo dòng mới cho bẳng và ghi vào các giá trị 
                var vRow = vTableBody.insertRow(gEND_ROW_TABLE);
                var vCellSTT = vRow.insertCell(gCOLUMN_STT);
                var vCellName = vRow.insertCell(gCOLUMN_NAME);
                var vCellEmail = vRow.insertCell(gCOLUMN_EMAIL);
                var vCellMessage = vRow.insertCell(gCOLUMN_MESSAGE);
                var vCellDate = vRow.insertCell(gCOLUMN_DATE);
                var vCellAction = vRow.insertCell(gCOLUMN_ACTION);

                vCellSTT.innerHTML = vContact.id;
                vCellName.innerHTML = vContact.name;
                vCellEmail.innerHTML = vContact.email;
                vCellMessage.innerHTML = vContact.message;
                vCellDate.innerHTML = vContact.createDate;
                vCellAction.className = "btn-group";
                //xử lí nút sửa
                var vButtonChange = document.createElement("button");
                vButtonChange.innerHTML = "Sửa";
                vButtonChange.className = 'btn btn-primary mr-2';
                vButtonChange.setAttribute("data-id", vContact.id);
                vButtonChange.setAttribute("onclick", 'onBtnSuaClick(this)');
                vCellAction.appendChild(vButtonChange);
                //xử lí nút xóa
                var vButtonDelete = document.createElement("button");
                vButtonDelete.innerHTML = "Xóa";
                vButtonDelete.className = 'btn btn-danger ml-2';
                vButtonDelete.setAttribute("data-id", vContact.id);
                vButtonDelete.setAttribute("onclick", 'onBtnXoaClick(this)');
                vCellAction.appendChild(vButtonDelete);
            }
        }
        
    

    function callApiDeleteContact(paramContactId, paramXmlHttpDeleteContact) {
        const vAPI_URL = gBASE_URL + "/contacts/";
        paramXmlHttpDeleteContact.open("DELETE", vAPI_URL + paramContactId, true);
        paramXmlHttpDeleteContact.send();
    }

    function informDeleteContact(paramContactId, paramXmlHttpDeleteContact) {
        paramXmlHttpDeleteContact.onreadystatechange = function () {
            // xóa thành công contact
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK)
                if (this.status == gREQUEST_STATUS_OK) {
                    console.log("Delete contact " + paramContactId + " thành công!");
                    alert("Xoá liên hệ thành công!");
                    getAllContacts();
                }
                else {
                    console.log("Delete contact " + paramContactId + " thất bại!");
                    alert("Xoá liên hệ thất bại!");
                    getAllContacts();
                }
        }
    }
</script>

</html>